#include <stdio.h>
#include <jpeglib.h>

void write_JPEG_file (	char * filename, 
												int quality, 
												char *image_buffer, 
												int image_height, 
												int image_width)
{
	struct jpeg_compress_struct cinfo;
	FILE * outfile;
	int row_stride;
	JSAMPROW row_pointer[1];
	struct jpeg_error_mgr jerr;

	if (filename==NULL)
	{
		return;
	};
	if (image_buffer==NULL)
	{
		return;
	};
	if ((outfile = fopen(filename, "wb")) == NULL) {
		fprintf(stderr, "can't open %s\n", filename);
		return;
	};
	
	cinfo.err = jpeg_std_error(&jerr);
	jpeg_create_compress(&cinfo);
	jpeg_stdio_dest(&cinfo, outfile);
	cinfo.image_width = image_width; 	/* image width and height, in pixels */
	cinfo.image_height = image_height;
	cinfo.input_components = 3;		/* # of color components per pixel */
	cinfo.in_color_space = JCS_RGB; 	/* colorspace of input image */
	jpeg_set_defaults(&cinfo);
	/* limit to baseline-JPEG values */
	jpeg_set_quality(&cinfo, quality, TRUE );
	jpeg_start_compress(&cinfo, TRUE);
	row_stride = image_width * 3;
	while (cinfo.next_scanline < cinfo.image_height) 
	{
		row_pointer[0] = & image_buffer[cinfo.next_scanline * row_stride];
		(void) jpeg_write_scanlines(&cinfo, row_pointer, 1);
	};
	jpeg_finish_compress(&cinfo);
	fclose(outfile);
	jpeg_destroy_compress(&cinfo);
	return;
};
